#### Previous topic

scipy.sparse.csgraph.dijkstra

#### Next topic

scipy.sparse.csgraph.bellman_ford

# scipy.sparse.csgraph.floyd_warshall

`scipy.sparse.csgraph.``floyd_warshall`(csgraph, directed=True, return_predecessors=False, unweighted=False, overwrite=False)

  Compute the shortest path lengths using the Floyd-Warshall algorithm

  New in version 0.11.0.

  Parameters:

  csgraph : array, matrix, or sparse matrix, 2 dimensions

  > The N x N array of distances representing the input graph.

  directed : bool, optional

  > If True (default), then find the shortest path on a directed graph: only move from point i to point j along paths csgraph[i, j]. If False, then find the shortest path on an undirected graph: the algorithm can progress from point i to j along csgraph[i, j] or csgraph[j, i]

  return_predecessors : bool, optional

  > If True, return the size (N, N) predecesor matrix

  unweighted : bool, optional

  > If True, then find unweighted distances. That is, rather than finding the path between each point such that the sum of weights is minimized, find the path such that the number of edges is minimized.

  overwrite : bool, optional

  > If True, overwrite csgraph with the result. This applies only if csgraph is a dense, c-ordered array with dtype=float64.

  Returns:

  dist_matrix : ndarray

  > The N x N matrix of distances between graph nodes. dist_matrix[i,j] gives the shortest distance from point i to point j along the graph.

  predecessors : ndarray

  > Returned only if return_predecessors == True. The N x N matrix of predecessors, which can be used to reconstruct the shortest paths. Row i of the predecessor matrix contains information on the shortest paths from point i: each entry predecessors[i, j] gives the index of the previous node in the path from point i to point j. If no path exists between point i and j, then predecessors[i, j] = -9999

  Raises:

  NegativeCycleError:

  > if there are negative cycles in the graph